package org.springframework.flex.samples;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.integration.annotation.Header;
import org.springframework.stereotype.Component;

import flex.messaging.MessageBroker;
import flex.messaging.services.MessageService;

@Component
public class ContactRegistry {

	private MessageBroker broker;
	
	@Autowired
	public void setMessageBroker(MessageBroker broker) {
		this.broker=broker;
	}
	
	public boolean isContactOnline(@Header String receiverName) {
		System.out.println("CHECKING IF CONTACT IS ONLINE");
		MessageService service = (MessageService) broker.getServiceByType(MessageService.class.getName());
		return service.getDestination(receiverName) != null;
	}
}
