package org.springframework.flex.samples;

import org.springframework.integration.annotation.Header;
import org.springframework.integration.core.Message;
import org.springframework.integration.message.MessageBuilder;
import org.springframework.integration.twitter.TwitterHeaders;
import org.springframework.stereotype.Component;

@Component
public class TwitterMessageCreator {

	public Message<?> create(@Header(TwitterHeaders.TO) String twitterId, String text) {
		System.out.println("SENDING TO TWITTER: " + twitterId + " -> " + text);
		return MessageBuilder.withPayload(text)
				.setHeader(TwitterHeaders.TO, twitterId).build();
	}
}
