package org.springframework.flex.samples;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.flex.messaging.MessageTemplate;
import org.springframework.flex.samples.contact.ContactDAO;
import org.springframework.integration.annotation.Header;
import org.springframework.stereotype.Component;

@Component
public class UserMessageSender {

	private final MessageTemplate template;
	
	private ContactDAO contactDAO;
	
	@Autowired
	public UserMessageSender(MessageTemplate template) {
		this.template = template;
	}
	
	@Autowired
	public void setContactDAO(ContactDAO contactDAO) {
		this.contactDAO = contactDAO;
	}
	
	public void send(@Header String senderName, @Header String receiverName, String text) {
		System.out.println("SENDING TO "+receiverName);
		PrivateMessage msg = new PrivateMessage();
		msg.setContact(contactDAO.findById(senderName));
		msg.setText(text);
		template.send(receiverName, msg);
	}
}
