package org.springframework.flex.samples.runtime.config;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Scope;
import org.springframework.flex.messaging.MessageDestinationFactory;
import org.springframework.security.context.SecurityContextHolder;

import flex.messaging.MessageBroker;

@Configuration
public class RuntimeDestinationConfig {
	
	private MessageBroker broker;
	
	@Autowired
	public void setBroker(MessageBroker broker) {
		this.broker = broker;
	}

	@Bean
	@Scope("prototype")
	public MessageDestinationFactory userDestination() {
		MessageDestinationFactory factory = new MessageDestinationFactory();
		String userId = SecurityContextHolder.getContext().getAuthentication().getName();
		factory.setMessageBroker(this.broker);
		factory.setDestinationId(userId);
		return factory;
	}
	
	@Bean
	public InstantMessengerService instantMessengerService() {
		return new InstantMessengerService() {
			@Override
			protected void doCreate() {
				userDestination();
			}
		};
	}
}